///////////////////////////////////////////////////////////////////
// DynamicMenuManager.h
// Ij[ǗNX
///////////////////////////////////////////////////////////////////

#pragma once

///////////////////////////////////////////////////////////////////
/// CDynamicMenuManager
///////////////////////////////////////////////////////////////////

class CDynamicMenuManager
{
public:

protected:
	CStringArray m_FileNames;
	BOOL		 m_bMenuLoaded;
	UINT		 m_nFirstItemID;

public:
	/// RXgN^
	/*+++virtual*/ CDynamicMenuManager();

	/// fXgN^
	virtual ~CDynamicMenuManager();

	/// j[ǂݍ
	virtual void Load(LPCTSTR lpszFileName) {;} 	//+++ add {}

	/// ݒj
	virtual void Release() {;}		//+++ add {}

	/// R}hs
	virtual CString GetCommandFile(UINT nID);

	/// ڐ擾
	virtual int GetItemCount();

	/// j[쐬
	virtual void CreateMenu(CMenu* pPopupMenu) {;}		//+++ add {}

	/// ǂݍ݃tO
	virtual BOOL IsSettingLoaded() { return m_bMenuLoaded; }
};


///////////////////////////////////////////////////////////////////
/// CFolderMenuManager
///////////////////////////////////////////////////////////////////

class CFolderMenuManager : public CDynamicMenuManager
{
protected:
	CString 		m_strRootFolder;
	CString 		m_strFileExt;
	UINT			m_nRootFlagID;
	int 			m_nItemBreakCount;
	int 			m_nMaxTextLength;
	CStringArray	m_FolderNames;
	//+++@CUIntArray m_FolderHandles;
	CPtrArray		m_FolderHandles;

public:
	/// RXgN^
	CFolderMenuManager(UINT nFirstItemID, UINT nRootFlagID, LPCTSTR lpszFileExt);

	/// 
	void Initialize(LPCTSTR lpszRootFolder, int nItemBreakCount, int nMaxTextLength );

	/// j[쐬
	void CreateMenu(CMenu* pPopupMenu);

protected:
	/// tH_̒gzɓǂݍ
	virtual void LoadFolderToArray(LPCTSTR lpszFileName, CStringArray& array);

	/// tH_ݒ̃j[ǉ
	virtual void AppendOptionalMenu(CMenu* pPopupMenu, int nItemIndex);
};


///////////////////////////////////////////////////////////////////
/// CFavoritesMenuManager
///////////////////////////////////////////////////////////////////

class CFavoritesMenuManager : public CFolderMenuManager
{
protected:
	// uɒǉv\
	BOOL m_bUseAddHere;
	// uׂĊJv\
	BOOL m_bUseOpenAll;
	// IEɕׂ
	BOOL m_bLoadIEOrder;

public:
	//// RXgN^
	CFavoritesMenuManager(UINT nFirstItemID, UINT nRootFlagID, LPCTSTR lpszFileExt);

	/// tH_CfbNX擾
	CString GetFolderPath(int index);

	/// }bvɃtH_ǉ
	void SetRootFolder(HMENU hMenu, LPCTSTR lpszFolder);

	/// 
	void Initialize(LPCTSTR lpszRootFolder, int nItemBreakCount, int nMaxTextLength, BOOL bLoadIEOrder, BOOL bUseAddHere, BOOL bUseOpenAll);

private:
	/// tH_̒gzɓǂݍ
	void LoadFolderToArray(LPCTSTR lpszFileName, CStringArray& array);

	/// tH_ݒ̃j[ǉ
	void AppendOptionalMenu(CMenu* pPopupMenu, int nItemIndex);
};


///////////////////////////////////////////////////////////////////
/// CSendMenuManager
///////////////////////////////////////////////////////////////////

class CSendMenuManager : public CDynamicMenuManager
{
protected:
	CString m_strFileName;

public:
	/// RXgN^
	CSendMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID);

	/// fXgN^
	~CSendMenuManager();

	/// j[ǂݍ
	virtual void Load(LPCTSTR lpszFileName);

	/// ݒj
	void Release();

	/// R}hs
	CString GetCommandFile(UINT nID);

	/// j[쐬
	virtual void CreateMenu(CMenu* pPopupMenu);
};


///////////////////////////////////////////////////////////////////
/// CProxyMenuManager
///////////////////////////////////////////////////////////////////

class CProxyMenuManager : public CSendMenuManager
{
public:
	/// RXgN^
	CProxyMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID);

	/// j[ǂݍ
	void Load(LPCTSTR lpszFileName);

	/// j[쐬
	void CreateMenu(CMenu* pPopupMenu);
};


///////////////////////////////////////////////////////////////////
/// CExtensionMenuManager
///////////////////////////////////////////////////////////////////

class CExtensionMenuManager : public CSendMenuManager
{
private:
	CUIntArray m_MenuOptions;

public:
	/// RXgN^
	CExtensionMenuManager(LPCTSTR lpszFileName, UINT nFirstItemID);

	/// R}hs
	CString GetCommandFile(UINT nID);

	/// j[쐬
	void CreateMenu(CMenu* pPopupMenu);

	/// j[̐ݒ擾
	UINT GetCommandMenuOption(UINT nID);
};
