/////////////////////////////////////////////////////////////////////////////
// FileTreeCtrl.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "FileTreeCtrl.h"
#include "patriotGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileTreeCtrl

CFileTreeCtrl::CFileTreeCtrl()
	: m_strSuffix()
	, m_strRootPath()
	, m_ClickedItem(0)
	, m_strOldFile()
	, m_strOldItem()
	, m_pDropTarget(NULL)
	, m_bEditing(FALSE)
	, m_bLoaded(FALSE)
	, m_posClicked()
	, m_iIconS(0)
	, m_iIconN(0)
{
  #if 0 //+++ Lɗ.
	m_bEditing		= FALSE;
	m_bLoaded		= FALSE;
	m_pDropTarget	= NULL;
  #endif
}

CFileTreeCtrl::~CFileTreeCtrl()
{
	if (m_pDropTarget) {
		delete m_pDropTarget;
	}
}


BEGIN_MESSAGE_MAP(CFileTreeCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(CFileTreeCtrl)
	ON_WM_CREATE()
	ON_COMMAND(ID_SIDEBAR_OPEN, OnSidebarOpen)
	ON_COMMAND(ID_SIDEBAR_OPENNEW, OnSidebarOpennew)
	ON_COMMAND(ID_SIDEBAR_REFRESHALL, OnSidebarRefreshall)
	ON_COMMAND(ID_SIDEBAR_PROPERTY , OnSidebarProperty)
	ON_COMMAND(ID_SIDEBAR_DELETE , OnSidebarDelete)
	ON_COMMAND(ID_SIDEBAR_RENAME , OnSidebarRename)
	ON_COMMAND(ID_SIDEBAR_NEWFOLDER , OnSidebarNewfolder)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, OnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileTreeCtrl bZ[W nh

/// EBhE\z
int CFileTreeCtrl::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CTreeCtrl::OnCreate( lpCreateStruct ) == -1) {
		return -1;
	}

	GetToolTips()->ModifyStyle( NULL, TTS_ALWAYSTIP | TTS_NOPREFIX );
	GetToolTips()->SetMaxTipWidth( 320 );
	GetToolTips()->Activate( TRUE );
	// OLE
	RegistDropTarget();
	return 0;
}

/// hbv^[Qbgo^
void CFileTreeCtrl::RegistDropTarget()
{
	if (m_pDropTarget) {	//+++ svAÔ߃K[h.
		assert(m_pDropTarget == 0);
		delete m_pDropTarget;
	}
	m_pDropTarget = new CFileTreeDropTarget;
	m_pDropTarget->RegisterWnd(this);
}

/// f[^ǉ
void CFileTreeCtrl::LoadData()
{
	if (!m_bLoaded) {
		m_bLoaded = TRUE;
	} else {
		return;
	}
	// C[W̃[h
	/*
	CString Path1 = AfxGetApp()->m_pszHelpFilePath;
	Path1 = Path1.Left(Path1.ReverseFind('\\'));
	CBitmap BMP_Tool;
	HBITMAP BMP_baf;
	m_Images.Create(16 , 16 , ILC_MASK | ILC_COLOR16 , 0 , 30);
	BMP_baf = ( HBITMAP )::LoadImage(NULL , Path1 +  _T("\\res\\sidebar.bmp") , IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach(BMP_baf);
	m_Images.Add(&BMP_Tool , RGB(255, 0, 255));
	SetImageList(&m_Images , TVSIL_NORMAL);
	*/

	//ModifyStyle( TVS_NOSCROLL, TVS_SINGLEEXPAND );	//+++ ߂.
	LockWindowUpdate();
	AddFolder( m_strRootPath, TVI_ROOT );
	UnlockWindowUpdate();

	// ܂Ȃ
	ModifyStyle( TVS_SINGLEEXPAND, TVS_NOSCROLL );
	HTREEITEM hRootItem = GetRootItem();
	SelectItem( hRootItem );
	EnsureVisible( hRootItem );
	ModifyStyle( TVS_NOSCROLL, TVS_SINGLEEXPAND );
}

/// ʐݒ
void CFileTreeCtrl::SetOption( CString inRoot, CString inSuffix, int inIcon, int inIconS )
{
	m_strRootPath = inRoot;
	m_strSuffix   = inSuffix;
	m_iIconN	  = inIcon;
	m_iIconS	  = inIconS;
}

/// Cɓ\z
void CFileTreeCtrl::AddFolder( CString strPath, HTREEITEM itemParent )
{
	// Ver1.0.03 폜@ύX
	/*
	while (GetChildItem(itemParent) != NULL) {
		DeleteItem(GetChildItem(itemParent));
	}
	*/

	// VtH_ǉ
	CStringArray order;
	if (g_Options.FavoritesIERegist && m_iIconN == 0) {
		// IE
		LoadRegFavorites( order, strPath );
	} else {
		//\[g
		LoadArrFolder( order, strPath, m_strSuffix );
	}

	int i	 = 0;
	int size = int( order.GetSize() );
	if (size == 0) {
		// tH_Ȃ̃ACeSč폜
		HTREEITEM item = GetChildItem(itemParent);
		while (item != NULL) {
			DeleteItem(item);
			item = GetChildItem(itemParent);
		}
		return;
	}

	// ̃ACeu
	HTREEITEM item = GetChildItem( itemParent );
	for (i = 0; i < size && item; i++) {
		HTREEITEM itemChild = GetChildItem( item );
		if (itemChild) {
			Expand( item, TVE_COLLAPSE );

			while (itemChild != NULL) {
				DeleteItem( itemChild );
				itemChild = GetChildItem( item );
			}
		}

		CString strItem = order.GetAt(i);
		strItem = strItem.Mid( strItem.ReverseFind('\\') + 1 );
		//strItem = strItem.Right( strItem.GetLength() - strItem.ReverseFind('\\') - 1 );

		if (strItem.Right(m_strSuffix.GetLength()).CompareNoCase(m_strSuffix) == 0) {
			// ACe
			strItem = strItem.Left( strItem.GetLength() - m_strSuffix.GetLength());
			SetItemText( item, strItem );
			SetItemImage( item, m_iIconN, m_iIconS );
		} else if (strItem.Right(4).CompareNoCase( _T(".lnk") ) != 0) {
			// tH_
			SetItemText( item, strItem );
			SetItemImage( item, 2, 3 );
			InsertItem( _T("no child"), m_iIconN, m_iIconS, item, TVI_LAST);
		}

		item = GetNextSiblingItem( item );
	}

	// c[ɒǉ
	for ( ; i < size; i++) {
		CString strItem = order.GetAt(i);
		strItem = strItem.Mid( strItem.ReverseFind('\\') + 1 );
		//strItem = strItem.Right( strItem.GetLength() - strItem.ReverseFind('\\') - 1 );

		if (strItem.Right(m_strSuffix.GetLength()).CompareNoCase(m_strSuffix) == 0) {
			// ACe
			strItem = strItem.Left( strItem.GetLength() - m_strSuffix.GetLength());
			InsertItem( strItem, m_iIconN, m_iIconS, itemParent, TVI_LAST);
		} else if (strItem.Right(4).CompareNoCase( _T(".lnk") ) != 0) {
			// tH_
			//+++ InsertItem( _T("no child"), m_iIconN, m_iIconS, InsertItem( strItem, 2, 3, itemParent, TVI_LAST ), TVI_LAST);
			HTREEITEM itemChild = InsertItem( strItem, 2, 3, itemParent, TVI_LAST );
			InsertItem( _T("no child"), m_iIconN, m_iIconS, itemChild, TVI_LAST);
		}
	}

	order.RemoveAll();
}

/// J
BOOL CFileTreeCtrl::OpenFile( BOOL bNewWindow )
{
	return FALSE;
}

CMenu* CFileTreeCtrl::GetContextMenu()
{
	return NULL;
}

/// I𒆂̃t@C擾
CString CFileTreeCtrl::GetSelectedFileName()
{
	//if (GetChildItem(m_ClickedItem))
	//	return	_T("");
	m_ClickedItem = GetSelectedItem();
	return GetItemFileName(m_ClickedItem);
}

/// ACẽt@C擾
CString CFileTreeCtrl::GetItemFileName( HTREEITEM item )
{
	if (item == NULL) {
		return m_strRootPath;
	}

	HTREEITEM itemNow	  = GetParentItem(item);
	CString   strFileName = GetItemText(item);
	while (itemNow) {
		strFileName = GetItemText(itemNow) + _T("\\") + strFileName;
		itemNow 	= GetParentItem(itemNow);
	}
	strFileName = m_strRootPath + _T("\\") + strFileName;

	/*
	while (GetParentItem(itemNow)) {
		strFileName = GetItemText(itemNow) + _T("\\") + strFileName;
		itemNow = GetParentItem(itemNow);
	}
	strFileName = m_strRootPath + _T("\\") + GetItemText(itemNow) + _T("\\") + strFileName;

	if (strFileName.Right(2) == _T("\\\\")) {
		CString strLastChar = strFileName.Mid( strFileName.GetLength() - 3, 2);
		if ( _tcsstr(DAMEMOJI_SO, strLastChar) == NULL) {
			strFileName = strFileName.Left( strFileName.GetLength() - 2 );
		}
	}
	if (strFileName.Right(1) == _T("\\") ) {
		strFileName = strFileName.Left( strFileName.GetLength() - 1 );
	}
	*/

	if (!ItemIsFolder(item)) {
		strFileName += m_strSuffix;
	}
	return strFileName;
}

BOOL CFileTreeCtrl::ItemIsFolder( HTREEITEM item )
{ // tH_𔻕
	/*
	if (item == GetRootItem())
		return TRUE;
	*/
	int iImage, iImageSelected;
	if (GetItemImage(item, iImage, iImageSelected)) {
		if (iImage == 2 && iImageSelected == 3) {
			return TRUE;
		}
	}
	return FALSE;
}

//+++ :tH_J^C~OŁA̒g܂ǂݍ
//		   Ȃ悤ȂAœǂݍ(̂Ƃ͖{̏)
void CFileTreeCtrl::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult)
{ // ACe̓WJ
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM	 itemNow	 = pNMTreeView->itemNew.hItem;

	if (pNMTreeView->action == TVE_EXPAND
			&& GetItemText(GetChildItem(itemNow)) == _T("no child")) {
		// t@Co
		CString strFileName;
		while (GetParentItem(itemNow)) {
			strFileName = GetItemText(itemNow) + _T("\\") + strFileName;
			itemNow 	= GetParentItem(itemNow);
		}
		strFileName 	= m_strRootPath + _T("\\") + GetItemText(itemNow) + _T("\\") + strFileName;
		HTREEITEM hItem = pNMTreeView->itemNew.hItem;
		AddFolder( strFileName, hItem );
	}

	/*+++:
	 *	ANSI-API  UNICODE-APIł *pResult̒lɂ鏈ĂB
	 *	ANSI-APIł truełfalse łʂ͓?ŁAc[̃tH_̊Js邪A
	 *	UNICODEł true ĕԂƁAc[̃tH_JoȂԁB
	 *	̓l̊֐ł̋vƁAUNICODEł͂炭 *pResult true
	 *	OnItemexpanding ̏萬Ŗ{͍̏sȂAdlƎv̂ŁA
	 *	ǂ炩ƂANSI-APIł*pResultĂȂȂ̂oOdlۂv...
	 *	(vc6,7.1,8,9 ...MFCłȂos?)
	 *	c킩Ă݂ΏC͂PӏȂł
	 *	cc2قǔɋꂵ񂾂orz
	 */
  #if 1 //defined UNICODE
	*pResult = false;		//+++ ̊֐ł͖Ȃ̂Ŗ{̏ɔC.
  #else
	*pResult = true;
  #endif
}

void CFileTreeCtrl::OnSidebarOpen()
{ // J
	OpenFile(FALSE);
}
void CFileTreeCtrl::OnSidebarOpennew()
{ // VEBhEŊJ
	OpenFile(TRUE);
}

void CFileTreeCtrl::OnSidebarProperty()
{ // vpeB
	SHELLEXECUTEINFO shei = { sizeof(SHELLEXECUTEINFO) };
	shei.fMask			  = SEE_MASK_INVOKEIDLIST | SEE_MASK_FLAG_NO_UI;
	shei.hwnd			  = m_hWnd; // I[i[EBhẼnh
	shei.lpVerb 		  = _T("properties");
	shei.lpFile 		  = GetSelectedFileName();
	::ShellExecuteEx(&shei);
}

void CFileTreeCtrl::OnSidebarDelete()
{ // 폜
	CString strFileName = GetSelectedFileName();
	if (strFileName== _T("") ) {
		return;
	}
	// WJĂ邩`FbN
	HTREEITEM item = GetSelectedItem();
	if (!ItemIsFolder(item)) {
		item	   = GetParentItem(item);
	}
	BOOL bExpand = FALSE;
	if (item) {
		bExpand  = GetItemState(item, TVIS_EXPANDED) & TVIS_EXPANDED;
	}

	if ( OperateFile(strFileName, _T(""), FO_DELETE, FOF_ALLOWUNDO) ) {
		DeleteItem(GetSelectedItem());
		if (bExpand) {
			// DeleteItem̓c[Ă܂̂ŊJ
			Expand(item, TVE_EXPAND);
		}
		SetFocus();
	}
	//else
	//	AfxMessageBox( _T("t@C̍폜Ɏs܂B") );
}

void CFileTreeCtrl::OnSidebarRename()
{ // ̕ύX
	ModifyStyle(NULL, TVS_EDITLABELS);
	HTREEITEM	hSelectedItem = GetSelectedItem();
	m_strOldItem = GetItemText(hSelectedItem);
	m_strOldFile = GetSelectedFileName();
	m_bEditing	 = TRUE;
	EditLabel(hSelectedItem);
}

void CFileTreeCtrl::OnSidebarNewfolder()
{ // tH_̍쐬
	CString 	strPath = GetSelectedFileName();
	if (strPath.GetAt(strPath.GetLength()-m_strSuffix.GetLength()) == '.') {
		strPath = strPath.Left(strPath.ReverseFind('\\'));
	}

	// c[ɃACeǉ
	HTREEITEM	item = GetSelectedItem();
	if (!ItemIsFolder(item)) {
		item = GetParentItem(item);
	}

	HTREEITEM	itemNewFolder;
	if (item && !(GetItemState(item, TVIS_EXPANDED) & TVIS_EXPANDED)) {
		Expand(item, TVE_EXPAND);
	}
	DoEvents();//Cxg
	itemNewFolder = InsertItem( _T("VtH_") , 2, 3, item, TVI_LAST);
	InsertItem( _T("no child") , m_iIconN, m_iIconS, itemNewFolder, TVI_LAST);

	// ۂ̃tH_쐬
	CString strFileName= _T("VtH_");
	int i = 0;
	while (!::CreateDirectory(strPath + _T("\\") + strFileName, NULL)) { // OȂ
		if (i > 0) {
			strFileName = strFileName.Left(strFileName.GetLength() - ItoStr(i).GetLength() -2);
		}
		if (i == 32) {// Su
			return;
		}
		i++;
		strFileName+= _T("(")+ ItoStr(i) + _T(")");
	}
	SetItemText(itemNewFolder, strFileName);

	// O̕ύX
	SelectItem(itemNewFolder);
	m_ClickedItem = itemNewFolder;
	OnSidebarRename();
}

/// XV
void CFileTreeCtrl::OnSidebarRefreshall()
{
	// tH_zuL
	HTREEITEM item;
	item = GetRootItem();
	// Ō̃c[̃t@C
	LockWindowUpdate();

	DeleteAllItems();
	AddFolder( m_strRootPath, TVI_ROOT );

	UnlockWindowUpdate();

	GetParent()->RedrawWindow();

	// ܂Ȃ
	ModifyStyle(TVS_SINGLEEXPAND, TVS_NOSCROLL);
	SelectItem(GetRootItem());
	EnsureVisible(GetRootItem());
	ModifyStyle(TVS_NOSCROLL , TVS_SINGLEEXPAND);
	// ̈ʒuɃXN[
	//	EnsureVisible(scrollTopItem);
}

/// j[̕\
void CFileTreeCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	if (point.x == -1) { // AvP[VL[őI
		m_ClickedItem = GetSelectedItem();
		CRect	rect;
		GetItemRect(m_ClickedItem, rect, FALSE);
		point.x = rect.left;point.y = rect.bottom;
	} else { // }EXőI
		ScreenToClient(&point);
		m_ClickedItem = HitTest(point);
	}

	if (m_ClickedItem == NULL) {
		return;
	}

	if (ItemIsFolder(m_ClickedItem)) {
		// tH_
		BOOL bExpand = GetItemState(m_ClickedItem, TVIS_EXPANDED) & TVIS_EXPANDED;
		if (bExpand == FALSE) {
			ModifyStyle(TVS_SINGLEEXPAND, NULL);
			SelectItem(m_ClickedItem);
			ModifyStyle(NULL, TVS_SINGLEEXPAND);
		}
		// SelectItem(m_ClickedItem);
	} else {
		// t@C
		SelectItem(m_ClickedItem);
	}
	CMenu* pPopup = GetContextMenu();
	ClientToScreen(&point);
	pPopup->GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, point.x, point.y, this, NULL);
	pPopup->Detach();
	delete pPopup;
}

BOOL CFileTreeCtrl::PreTranslateMessage(MSG* pMsg)
{
	// L[ŊJ
	if (pMsg->message == WM_KEYDOWN) {
		// ^[L[
		if (pMsg->wParam == VK_RETURN) {
			m_ClickedItem = GetSelectedItem();
			HTREEITEM itemSelect = m_ClickedItem;
			if (m_bEditing) // ҏWI
				SetFocus();
			else if ( !OpenFile((GetKeyState(VK_SHIFT) & 0x8000) ? !g_Options.bNWFavorites :  g_Options.bNWFavorites) ) { // t@CJ
				if (ItemIsFolder(itemSelect)) { // c[WJ
					ModifyStyle(TVS_SINGLEEXPAND, TVS_NOSCROLL);

					if (GetItemState(itemSelect, TVIS_EXPANDED) & TVIS_EXPANDED) {
						Expand(itemSelect, TVE_COLLAPSE);
					} else {
						HTREEITEM itemRoot = itemSelect;
						while (GetParentItem(itemRoot)) {
							itemRoot = GetParentItem(itemRoot);
						}

						HTREEITEM item = itemRoot;
						while ((item = GetPrevSiblingItem(item)) != 0) {
							Expand(item, TVE_COLLAPSE);
						}

						item = itemSelect;
						while ((item = GetPrevSiblingItem(item)) != 0) {
							Expand(item, TVE_COLLAPSE);
						}

						item = itemSelect;
						while((item = GetNextVisibleItem(item)) != 0) {
							Expand(item, TVE_COLLAPSE);
						}

						Expand(itemSelect, TVE_EXPAND);
					}

					ModifyStyle(TVS_NOSCROLL, TVS_SINGLEEXPAND);
				}
				return CTreeCtrl::PreTranslateMessage(pMsg);
			}
		}
	}
	GetToolTips()->RelayEvent(pMsg);
	return CTreeCtrl::PreTranslateMessage(pMsg);
}

void CFileTreeCtrl::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult)
{
	NMTREEVIEW* pNMTreeView = (NMTREEVIEW*)pNMHDR;
	if (pNMTreeView->action ==TVC_BYKEYBOARD) { // I̕ύX
		m_ClickedItem = pNMTreeView->itemNew.hItem;
	}
	/*
	if (pNMTreeView->action ==TVC_BYMOUSE) { // I̕ύX
		m_ClickedItem = pNMTreeView->itemNew.hItem;
		if (!ItemIsFolder(m_ClickedItem)) { // J
			CPoint pt;GetCursorPos(&pt);
			if (pt != m_posClicked) {
				GetCursorPos(&m_posClicked);
				OpenFile((GetKeyState(VK_SHIFT)) ? !g_Options.bNWFavorites :  g_Options.bNWFavorites);
				AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_VIEW_FOCUS_VIEW);
			}
		}
	}
	*/
	*pResult = 0;
}

/// OnDbClick
void CFileTreeCtrl::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult)
{
	*pResult = 0;
}

void CFileTreeCtrl::OnTimer(UINT_PTR nIDEvent)
{
	CTreeCtrl::OnTimer(nIDEvent);
}

/// c[`bṽ^O擾
void CFileTreeCtrl::SetToolTipInfo(CPoint point)
{
	GetToolTips()->Pop();
	GetToolTips()->DelTool( this, 1 );
	CRect rect;GetClientRect( rect );

	HTREEITEM	itemNow 	= HitTest( point );
	CString 	strFileName = GetItemText( itemNow );

	if ( ItemIsFolder( itemNow ) ) { // tH_
		GetToolTips()->AddTool( this, strFileName, rect, 1 );
	}
	else{ // t@C
		// pX擾
		CString strPath = _T("");
		while ( GetParentItem( itemNow ) ) {
			itemNow = GetParentItem( itemNow );
			strPath = GetItemText( itemNow ) +	_T("\\")  + strPath;
		}

		strPath = m_strRootPath +  _T("\\")  + strPath + strFileName + m_strSuffix;
		CString strURL;
		TCHAR buf[255];
		GetPrivateProfileString( _T("InternetShortcut"), _T("URL"), _T(""), buf, 255, strPath);
		strURL = buf;

		CString strComment;
		GetPrivateProfileString( _T("Donut"), _T("memo"), _T(""), buf, 255, strPath );
		if (buf[0] != NULL) {
			strComment.Format( _T("\n%s") , buf);
		}
		GetToolTips()->AddTool( this, strFileName + _T("\n") + strURL + strComment, rect, 1);
	}
}

void CFileTreeCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	// c[`bv
	static int TooltipY = -1/*+++0*/;
	if ( TooltipY != point.y ) {
		SetToolTipInfo( point );
		TooltipY = point.y;

		// hbO
		if (nFlags & MK_LBUTTON) {

		}
	}
	CTreeCtrl::OnMouseMove(nFlags, point);
}

/// hbOJn
void CFileTreeCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	CTreeCtrl::OnLButtonDown(nFlags, point);
}

/// hbvI
void CFileTreeCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	CTreeCtrl::OnLButtonUp(nFlags, point);
}

void CFileTreeCtrl::OnClick(NMHDR* pNMHDR, LRESULT* pResult)
{
	CPoint pt;
	GetCursorPos(&pt);
	if (m_posClicked == pt) {
		return;
	}
	m_posClicked = pt;

	ScreenToClient( &pt );
	m_ClickedItem = HitTest( pt );

	if ( m_ClickedItem != NULL && !ItemIsFolder( m_ClickedItem ) ) {
		SelectItem( m_ClickedItem );

		OpenFile( (GetKeyState(VK_SHIFT) & 0x8000) ? !g_Options.bNWFavorites :	g_Options.bNWFavorites );
		AfxGetMainWnd()->PostMessage( WM_COMMAND, ID_VIEW_FOCUS_VIEW );
	}
	*pResult = 0;
}

/// ҏW̏I
void CFileTreeCtrl::OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult)
{
	TV_DISPINFO* pTVDispInfo = (TV_DISPINFO*)pNMHDR;

	m_bEditing = FALSE;
	ModifyStyle(TVS_EDITLABELS, NULL);
	if (pTVDispInfo->item.pszText == 0 || GetKeyState(VK_RETURN) == FALSE) { // LZ
		SetItemText(GetSelectedItem(), m_strOldItem);
		*pResult = 1;
	} else { // ύX
		SetItemText(GetSelectedItem(), pTVDispInfo->item.pszText);
		CString strNewFile = GetSelectedFileName();

		if (_trename(m_strOldFile, strNewFile)!=0) {
			AfxMessageBox( _T("O̕ύXɎs܂B") );
			OnSidebarRefreshall();
			*pResult = 1;
			return;
		}
		*pResult = 0;
	}
}

/// t@Chbvꂽ
BOOL CFileTreeCtrl::OnDropFiles(HTREEITEM ItemDrop, COleDataObject* pDataObject)
{
	// hbṽtH_
	CString strPath = GetItemFileName(ItemDrop);

	// 
	enum { CHRFILE_NUM = 128/*+++64*/ };
	TCHAR chrFile[CHRFILE_NUM][_MAX_PATH];
	UINT	nFiles	  = 0;
	HGLOBAL hData	  = pDataObject->GetGlobalData(CF_HDROP);
	HDROP	hDropInfo = (HDROP)GlobalLock(hData);
	nFiles=::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	if (nFiles >= CHRFILE_NUM)	//+++ zȂōő吔K[hƂ.
		nFiles	= CHRFILE_NUM;

	// pXzɊi[
	for (UINT iFile = 0; iFile < nFiles; iFile++) {
		::DragQueryFile(hDropInfo, iFile, chrFile[iFile], _MAX_PATH);
	}
	::DragFinish(hDropInfo);
	GlobalUnlock(hData);
	::GlobalFree(hData);

	// ۂɃRs[
	for (UINT i = 0;i<nFiles;i++) { // Rs[
		if ( _tcsicmp( chrFile[i] + lstrlen(chrFile[i] ) - m_strSuffix.GetLength(), m_strSuffix)  == 0//Ƀc[ɕ\gqƓ
			|| _tcschr(_tcschr(chrFile[i], '\\'), '.') == NULL ){ //  . Ȃ
			BOOL bResult = OperateFile(chrFile[i], strPath+_tcsrchr(chrFile[i], '\\'), FO_MOVE, FOF_ALLOWUNDO | FOF_MULTIDESTFILES);
			if (bResult) { // c[ɒǉ
				CString strTitle = _tcschr(chrFile[i], _T('\\')) + 1;
				if (strTitle.Right( m_strSuffix.GetLength() ).CompareNoCase(m_strSuffix)) {// gq폜
					strTitle = strTitle.Left( strTitle.GetLength() - m_strSuffix.GetLength() );
				}
				// ACëړ
				LockWindowUpdate();
				AddFolder( strPath, ItemDrop );
				UnlockWindowUpdate();
			} else {
				return FALSE;
			}
		}
	}
	return TRUE;
}

/// Nhbvꂽ
BOOL CFileTreeCtrl::OnDropLink(HTREEITEM ItemDrop, CString strTitle, CString strURL)
{
	// hbṽtH_
	CString strPath = GetItemFileName(ItemDrop);
	WriteShortcut( strPath + _T("\\") + strTitle, strURL );

	// ACëړ
	LockWindowUpdate();
	AddFolder( strPath, ItemDrop );
	UnlockWindowUpdate();
	return TRUE;
}

/// ACehbvꂽ
BOOL CFileTreeCtrl::OnDropItem(HTREEITEM ItemDrop, HTREEITEM ItemDrag)
{
	if (ItemDrop == ItemDrag) {
		return FALSE;
	}
	CString strPathOld = GetItemFileName(ItemDrag);
	CString strPathNew = GetItemFileName(ItemDrop);

//	shFile.fFlags = FOF_ALLOWUNDO | FOF_MULTIDESTFILES;// | FOF_NOCONFIRMMKDIR | FOF_RENAMEONCOLLISION
	BOOL bResult = FALSE;
	if (strPathOld.Right(m_strSuffix.GetLength()).CompareNoCase(m_strSuffix) == 0) {// ̕񂪃c[ɕ\gqƓ
		strPathNew += _T("\\") + GetItemText(ItemDrag) + m_strSuffix;
	} else if (strPathOld.Find( _T('.'), strPathOld.ReverseFind( _T('\\') ) ) == -1) {// tH_
		strPathNew += _T("\\") + GetItemText(ItemDrag);
	} else {
		strPathNew = _T("");
	}
	if (!strPathNew.IsEmpty() && strPathNew != strPathOld) {
		bResult = OperateFile( strPathOld, strPathNew, FO_MOVE, FOF_ALLOWUNDO | FOF_MULTIDESTFILES );
	}

	if (bResult) { // c[ɒǉ
		// ACëړ
		LockWindowUpdate();
		AddFolder( GetItemFileName(ItemDrop), ItemDrop );
		UnlockWindowUpdate();
		return TRUE;
	} else {
		return FALSE;
	}
	//+++ return FALSE; 	//+++ ɂȂ.
}

/// hbO̊Jn
void CFileTreeCtrl::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	// hbOACe擾
	HTREEITEM item = pNMTreeView->itemNew.hItem;//HitTest( point );
	SelectItem(item);

	//	f[^\[XIuWFNgCX^X
	COleDataSource	dataSource;
	CString strPath = GetItemFileName( item );
	HGLOBAL hData	= CreateOLEText( strPath );//TEXT
	HDROP	hDrop	= CreateOLEHDrop( strPath );//t@C
	dataSource.CacheGlobalData( BURA_CF_TEXT , hData );
	dataSource.CacheGlobalData( CF_HDROP, hDrop );

	HGLOBAL 	hDragItem = ::GlobalAlloc( GMEM_SHARE | GMEM_ZEROINIT, sizeof(HTREEITEM) );
	HTREEITEM*	pItem	  = (HTREEITEM*)::GlobalLock(hDragItem);
	*pItem = item;
	::GlobalUnlock( hDragItem );

	// 쐬f[^ݒ
	CLIPFORMAT cfmt   = static_cast<CLIPFORMAT>(::RegisterClipboardFormat(_T("Bura.TreeItem")));
	dataSource.CacheGlobalData( cfmt, hDragItem );

	DROPEFFECT result = dataSource.DoDragDrop( DROPEFFECT_COPY | DROPEFFECT_MOVE );
	if (result == DROPEFFECT_MOVE) {
		// 폜
		DeleteItem(item);
	}

	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// CFileTreeDropTarget
//////////////////////////////////////////////////////////////////////

CFileTreeDropTarget::CFileTreeDropTarget()
	: m_pTreeWnd(0)
{
}

CFileTreeDropTarget::~CFileTreeDropTarget()
{
}

/// eEBhEo^
void CFileTreeDropTarget::RegisterWnd(CTreeCtrl* pTreeWnd)
{
	m_pTreeWnd = pTreeWnd;
	Register(pTreeWnd);
}

/// hbO
DROPEFFECT CFileTreeDropTarget::OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	//BOOL bItemInsert = FALSE;
	HTREEITEM item = m_pTreeWnd->HitTest(point);
	if (!item) {
		// hbvs̈
		return DROPEFFECT_NONE;
	}

	if (!((CFileTreeCtrl*)m_pTreeWnd)->ItemIsFolder(item)) {
		item = m_pTreeWnd->GetParentItem(item);
	}
	m_pTreeWnd->SelectDropTarget(item);
	m_pTreeWnd->SetInsertMark(NULL, FALSE);

	return DROPEFFECT_COPY;
}

/// EBhE痣ꂽ
void CFileTreeDropTarget::OnDragLeave( CWnd* pWnd )
{
	m_pTreeWnd->SetInsertMark(NULL, FALSE);
	m_pTreeWnd->SelectDropTarget(NULL);
}

/// hbv
DROPEFFECT CFileTreeDropTarget::OnDropEx( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point )
{
	// c[hbṽc[ACe擾
	CString 		strPath;
	CFileTreeCtrl*	pTree = (CFileTreeCtrl*)m_pTreeWnd;
	HTREEITEM		item  = pTree->HitTest(point);
	if (!((CFileTreeCtrl*)m_pTreeWnd)->ItemIsFolder(item)) {
		item = pTree->GetParentItem(item);
	}

	// hbṽtH_
	strPath = pTree->GetItemFileName(item);

	// hbvnCCg
	m_pTreeWnd->SetInsertMark(NULL, FALSE);
	m_pTreeWnd->SelectDropTarget(NULL);

	// c[ACe
	CLIPFORMAT CF_BURATREEITEM	= static_cast<CLIPFORMAT>(::RegisterClipboardFormat(_T("Bura.TreeItem")));
	CLIPFORMAT CF_SHELLURL		= static_cast<CLIPFORMAT>(::RegisterClipboardFormat(CFSTR_INETURL/*+++CFSTR_SHELLURL*/));
	RegisterClipboardFormat((CFSTR_INETURL/*+++CFSTR_SHELLURL*/));
	if (pDataObject->IsDataAvailable(CF_BURATREEITEM)) {
		HGLOBAL 	hData		= pDataObject->GetGlobalData(CF_BURATREEITEM);
		HTREEITEM	itemDrag	= *(HTREEITEM *)GlobalLock(hData);
		GlobalUnlock(hData);
		::GlobalFree(hData);
		return pTree->OnDropItem(item, itemDrag) ? DROPEFFECT_MOVE : DROPEFFECT_NONE;
	// t@C
	} else if (pDataObject->IsDataAvailable(CF_HDROP)) {
		return pTree->OnDropFiles(item, pDataObject) ? DROPEFFECT_MOVE : DROPEFFECT_NONE;
	// N
	} else if (pDataObject->IsDataAvailable(CF_SHELLURL)) {
		// URL擾
		TCHAR			chrText[MAX_PATH];
		HGLOBAL 		hData	= pDataObject->GetGlobalData(BURA_CF_TEXT);
		const TCHAR*	ptr 	= (const TCHAR *)GlobalLock(hData);
		lstrcpyn(chrText, ptr, MAX_PATH);
		GlobalUnlock(hData);
		::GlobalFree(hData);
		// ^Cg擾
		hData = pDataObject->GetGlobalData((CLIPFORMAT)RegisterClipboardFormat(CFSTR_FILEDESCRIPTOR));
		FILEGROUPDESCRIPTOR* fd 	  = (FILEGROUPDESCRIPTOR*)GlobalLock(hData);
		CString 			 strTitle = fd->fgd[0].cFileName;

		GlobalUnlock(hData);
		::GlobalFree(hData);

		return pTree->OnDropLink(item, strTitle, chrText) ? DROPEFFECT_COPY  :	DROPEFFECT_NONE;
	}
	return DROPEFFECT_NONE;
}
