/////////////////////////////////////////////////////////////////////////////
// InternetProtocol.h: Definition of the CInternetProtocol class
//
/////////////////////////////////////////////////////////////////////////////
#pragma once

#include "stdafx.h"

/////////////////////////////////////////////////////////////////////////////
/// CInternetProtocol
/////////////////////////////////////////////////////////////////////////////

class CInternetProtocol
 : public IInternetProtocol
{
private:
	/// QƃJE^
	ULONG count;
public:
	/// RXgN^
	CInternetProtocol() : count(0) {
		AddRef();
	}
private:
	/// fXgN^
	virtual ~CInternetProtocol() {
	}

public:
	///----------------------------------------------------------------------------
	/// IInternetProtocolRoot 
	///----------------------------------------------------------------------------

	STDMETHODIMP Start(LPCWSTR szUrl, IInternetProtocolSink *pIProtSink
					   , IInternetBindInfo *pIBindInfo, DWORD grfSTI, HANDLE_PTR dwReserved);

	STDMETHODIMP Continue(PROTOCOLDATA *pStateInfo) {return S_OK;}

	STDMETHODIMP Abort(HRESULT hrReason,DWORD dwOptions) {
		ATLTRACENOTIMPL("Resume\n");
		return E_NOTIMPL;
	}

	STDMETHODIMP Terminate(DWORD dwOptions) {return  S_OK;}

	STDMETHODIMP Suspend()
	{
		ATLTRACENOTIMPL("Resume\n");
		return E_NOTIMPL;
	}

	STDMETHODIMP Resume()
	{
		ATLTRACENOTIMPL("Resume\n");
		return E_NOTIMPL;
	}


	///----------------------------------------------------------------------------
	/// IInternetProtocol 
	///----------------------------------------------------------------------------

	STDMETHODIMP Read(void *pv,ULONG cb,ULONG *pcbRead);

	STDMETHODIMP Seek (
			LARGE_INTEGER dlibMove,
			DWORD dwOrigin,
			ULARGE_INTEGER *plibNewPosition)
	{
		ATLTRACENOTIMPL("Seek\n");
		return E_NOTIMPL;
	}

	STDMETHOD(LockRequest)(DWORD dwOptions) {return S_OK;}

	STDMETHOD(UnlockRequest)(void) {return S_OK;}		//+++ add void.


	///----------------------------------------------------------------------------
	/// IUnknown 
	///----------------------------------------------------------------------------

	STDMETHOD(QueryInterface)(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject)
	{
		if (IsEqualIID(riid, IID_IInternetProtocol)
			|| IsEqualIID(riid, IID_IInternetProtocolRoot)
			|| IsEqualIID(riid, IID_IUnknown)) {
			if (ppvObject == NULL) {
				return E_POINTER;
			}
			*ppvObject = static_cast<IInternetProtocol*>(this);
			AddRef();
			return S_OK;
		} else {
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef()
	{
		return ++count;
	}

	ULONG STDMETHODCALLTYPE Release()
	{
		if (--count == 0) {
			delete this;
		}
		return count;
	}

};

/////////////////////////////////////////////////////////////////////////////
/// CProtocolFactory
/////////////////////////////////////////////////////////////////////////////

class CProtocolFactory
 : public IClassFactory
{
private:
	/// QƃJE^
	ULONG count;
public:
	/// RXgN^
	CProtocolFactory() : count(0) {
		//+++ AddRef(); //+++ 󂯎肪ComPtrɑĂ̂łłȂق悳.
	}
private:
	/// fXgN^
	virtual ~CProtocolFactory() {
	}
public:
	///----------------------------------------------------------------------------
	/// IClassFactory
	///----------------------------------------------------------------------------

	HRESULT STDMETHODCALLTYPE CreateInstance(IUnknown *pUnkOuter, REFIID riid, void **ppvObject)
	{
		if (IsEqualIID(riid, IID_IUnknown) || IsEqualIID(riid, IID_IInternetProtocol)) {
			CInternetProtocol* pProtocol = new CInternetProtocol;
			return pProtocol->QueryInterface(riid, ppvObject);
		} else {
			return E_NOINTERFACE;
		}
	}

	HRESULT STDMETHODCALLTYPE LockServer(BOOL fLock)
	{
		return S_OK;
	}


	///----------------------------------------------------------------------------
	/// IUnknown 
	///----------------------------------------------------------------------------

	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (IsEqualIID(riid, IID_IUnknown) || IsEqualIID(riid, IID_IClassFactory)) {
			if (ppvObject == NULL) {
				return E_POINTER;
			}
			*ppvObject = static_cast<IClassFactory*>(this);
			AddRef();
			return S_OK;
		} else {
			*ppvObject = NULL;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return ++count;
	}

	ULONG STDMETHODCALLTYPE Release() {
	  #if 1 	//+++ deleteɃo[ϐcountQƂ͕̂ŝŏC.
		ULONG  c = count;
		if (c)
			c = --count;
		if (c == 0)
			delete this;
		return c;
	  #else
		if (--count == 0) {
			delete this;
		}
		return count;
	  #endif
	}
};
