/////////////////////////////////////////////////////////////////////////////
// PatriotSearchbar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "PatriotSearchbar.h"
#include "patriotGlobal.h"
#include "patriotView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IDC_TOOLBAR_SEARCHBAR AFX_IDW_TOOLBAR + 1

/////////////////////////////////////////////////////////////////////////////
// CPatriotSearchbar _CAO


CPatriotSearchbar::CPatriotSearchbar(CWnd* pParent /*=NULL*/)
	: CDialogBar()
	, m_wndToolBar()
	, m_oDropTarget()
	, m_imgLst()
	, m_arrEngines()
	, m_nActiveEngine(-1)
{
	//{{AFX_DATA_INIT(CPatriotSearchbar)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CPatriotSearchbar::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPatriotSearchbar)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPatriotSearchbar, CDialogBar)
	//{{AFX_MSG_MAP(CPatriotSearchbar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_SEARCH_WEB, OnSearchWeb)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_WEB, OnUpdateSearchWeb)
	ON_COMMAND(ID_SEARCH_PAGE, OnSearchPage)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_PAGE, OnUpdateSearchPage)
	ON_COMMAND(ID_SEARCH_HILIGHT, OnSearchHilight)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_HILIGHT, OnUpdateSearchHilight)
	ON_CBN_SETFOCUS(IDC_COMBO1, OnSetfocusCombo1)
	ON_WM_DESTROY()
	ON_WM_MOUSEWHEEL()
	ON_CBN_KILLFOCUS(IDC_COMBO1, OnKillfocusCombo1)
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
	ON_NOTIFY(TBN_DROPDOWN, IDC_TOOLBAR_SEARCHBAR, OnDropDown)
END_MESSAGE_MAP()

LONG_PTR CPatriotSearchbar::m_pComboBoxDefWndProc = 0;		//+++@ ?_PTR

/////////////////////////////////////////////////////////////////////////////
// CPatriotSearchbar \bh

/// y[WJ
void CPatriotSearchbar::GoUrl()
{
	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);

	CString str;
	pCombo1->GetWindowText(str);
	if ( str.IsEmpty() ) {
		return;
	}

	BOOL bShift = GetKeyState(VK_SHIFT)   & 0x8000;
	BOOL bCtrl	= GetKeyState(VK_CONTROL) & 0x8000;

	/*
	if (str.GetAt(0) == _T('0')) { // GWύX
		if (str.GetAt(1) != _T('x')) {
			pCombo1->SetCurSel( _ttoi( str.Left(str.Find(_T(' '))) ) );
		}
		// 0x폜
		str = str.Mid( str.Find(' ') + 1 );
		// str = str.Right(str.GetLength() - str.Find(' ') - 1);
		pCombo2->SetWindowText(str);
	}
	*/

	CString str2 = m_arrEngines.GetAt(m_nActiveEngine);
	if (bShift && bCtrl) {
		str2 = g_Options.strSearchCtrl3;
	} else if (bCtrl) {
		str2 = g_Options.strSearchCtrl1;
	} else if (bShift) {
		str2 = g_Options.strSearchCtrl2;
	}

	OpenSendstring( str2, str, g_Options.bNWSendstr );

	InsertHistory(str);
}

/// ɒǉ
void CPatriotSearchbar::InsertHistory(CString str)
{
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO1);
	pCombo->InsertString(0 , str);
	pCombo->SetCurSel(0);

	// d폜
	CString str2;
	int i = 0;
	for (i = 1; i < pCombo->GetCount(); i++) {
		pCombo->GetLBText(i, str2);
		if (str == str2) {
			pCombo->DeleteString(i);
		}
	}
	// ۑ葽폜
	if (g_Options.SearchHistoryCount > 0) {
		for (i = pCombo->GetCount()-1; i > g_Options.SearchHistoryCount; i--) {
			pCombo->DeleteString(i);
		}
	}
}

/// f[^ǂݍ
void CPatriotSearchbar::LoadItem()
{
	// R{{bNXTuNX
	if (m_pComboBoxDefWndProc == NULL) {
		HWND hComboEditWnd = GetDlgItem(IDC_COMBO1)->GetTopWindow()->m_hWnd;
	  #if _MSC_VER >= 1300	//+++ 64bitΉAPIύX.
		m_pComboBoxDefWndProc = ::GetWindowLongPtr( hComboEditWnd, GWLP_WNDPROC );
		::SetWindowLongPtr( hComboEditWnd, GWLP_WNDPROC, (LONG_PTR)ComboBoxWndProc );
	  #else
		m_pComboBoxDefWndProc = ::GetWindowLong( hComboEditWnd, GWL_WNDPROC );
		::SetWindowLong( hComboEditWnd, GWL_WNDPROC, (LONG)ComboBoxWndProc );
	  #endif
	}
	// ANeBuȃGWݒ
	if (m_nActiveEngine == -1) {
		m_nActiveEngine = AfxGetApp()->GetProfileInt( _T("Search"), _T("Default"), 0 );
	}
	m_arrEngines.RemoveAll();

	CString str;
	CString strPath = g_Options.strOptionPath + ((g_Options.SearchUseSendstr) ? _T("\\sendstr.dat") : _T("\\search.dat") );

	// ACeǍ
	try {
		//+++ CStdioFile fin( strPath, CFile::modeRead );
		CReadTextFile fin( strPath, CFile::modeRead );
		while (fin.ReadString(str)) {
			if (str.GetAt(0) != '#') {
				m_arrEngines.Add(str);
			}
		}
		fin.Close();
	} catch (CFileException* e) {
		if (e->m_cause != CFileException::fileNotFound){
			e->ReportError();
		}
		e->Delete();
	}

	if (m_nActiveEngine < 0  || m_nActiveEngine >= m_arrEngines.GetSize()) {
		m_nActiveEngine = 0;
	}
}

// ͗ǂݍ
void CPatriotSearchbar::LoadHistory()
{
	if (g_Options.SearchHistoryCount > 0) {
		TRY{
			CComboBox* pCombo = static_cast<CComboBox*>( GetDlgItem(IDC_COMBO1) );
			pCombo->ResetContent();

			//+++ CStdioFile fso( g_Options.strOptionPath + _T("\\srchhist.dat"), CFile::modeRead );
			CReadTextFile fso( g_Options.strOptionPath + _T("\\srchhist.dat"), CFile::modeRead );
			CString str;
			while (fso.ReadString(str)) {
				pCombo->AddString(str);
			}
			fso.Close();
		}
		CATCH( CFileException, e ){
			if ( e->m_cause != CFileException::fileNotFound) {
				TRACE( _T("File could not be opened %d \n")  , e->m_cause);
			}
		}END_CATCH
	}
}

/// hbv_Ẽj[\
void CPatriotSearchbar::ShowDropDownMenu()
{
	CMenu menu;
	menu.CreatePopupMenu();

	CRect rectButton;
	m_wndToolBar.GetItemRect( 0, rectButton );
	m_wndToolBar.ClientToScreen( rectButton );

	int nSize = int( m_arrEngines.GetSize() );

	for (int i = 0; i < nSize; i++) {
		CString strTitle = m_arrEngines.GetAt(i);

		if (strTitle.Left(2)== _T("--") ) {
			// Zp[^[
			menu.AppendMenu(MF_SEPARATOR , NULL, _T("") );
		} else {
			// V[gJbg\
			if (strTitle == g_Options.strSearchCtrl1) {
				strTitle+= _T("\tCtrl+Enter");
			}
			if (strTitle == g_Options.strSearchCtrl2) {
				strTitle+= _T("\tShift+Enter");
			}
			if (strTitle == g_Options.strSearchCtrl3) {
				strTitle+= _T("\tCtrl+Shift+Enter");
			}

			UINT nFlag = (i == m_nActiveEngine) ? MF_STRING | MF_CHECKED : MF_STRING;
			menu.AppendMenu(nFlag, ID_SEARCH_GO + i, strTitle);
		}
	}
	menu.SetDefaultItem(ID_SEARCH_GO + m_nActiveEngine);

	// j[\
	UINT uItem = TrackPopupMenu( menu.m_hMenu, TPM_RIGHTALIGN | TPM_RETURNCMD, rectButton.right, rectButton.bottom, 0, m_hWnd, NULL );
	if (uItem > 0) {
		m_nActiveEngine = uItem - ID_SEARCH_GO;

		if (g_Options.SearchGoItemChanged) {
			GoUrl();
		}
		GetDlgItem(IDC_COMBO1)->GetTopWindow()->RedrawWindow();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPatriotSearchbar bZ[W nh

/// \z
int CPatriotSearchbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialogBar::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	// OLE
	m_oDropTarget.m_nParent = OLE_TARGET_SEARCHBAR;
	m_oDropTarget.Register(this);

	// BMPǂݍ
	/*
	HANDLE hFind;
	WIN32_FIND_DATA fd;
	hFind = FindFirstFile(g_Options.strAppPath +  _T("\\res\\search.bmp") , &fd);
	if (hFind != INVALID_HANDLE_VALUE) {
	*/
	CBitmap bmpTool;
	HBITMAP hBmpBuffer;
	hBmpBuffer = ( HBITMAP )::LoadImage(NULL, g_Options.strAppPath + _T("\\res\\search.bmp") , IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	bmpTool.Attach(hBmpBuffer);

	m_imgLst.Create(16, 16, ILC_MASK | ILC_COLOR16, 0, 3);
	m_imgLst.Add(&bmpTool, RGB(255, 0, 255));
	/*
	} else {
		m_imgLst.Create(IDB_BITMAP1 , 16 , 2 , RGB(255 , 0 , 255));
	}
	::FindClose(hFind);
	*/
	RECT rectToolbar = {0, 0, 0, 0};
	m_wndToolBar.CreateEx(this, 0, WS_CHILD | WS_VISIBLE | CBRS_ALIGN_TOP | CBRS_TOOLTIPS | CBRS_SIZE_DYNAMIC, rectToolbar, IDC_TOOLBAR_SEARCHBAR);
	m_wndToolBar.ModifyStyle( 0, TBSTYLE_FLAT | TBSTYLE_TOOLTIPS | CCS_NOMOVEY | TBSTYLE_TRANSPARENT /*| CCS_ADJUSTABLE*/ );

	SIZE size1 = {23, 22};
	SIZE size2 = {16, 16};
	m_wndToolBar.SetSizes( size1, size2 );

	m_wndToolBar.GetToolBarCtrl().SetImageList(&m_imgLst);
	//m_wndToolBar.GetToolBarCtrl().SetHotImageList(&m_imgLst);

	TBBUTTON BT[3];
	BT[0].iBitmap	= 0;
	BT[0].iString	= 0;
	BT[0].idCommand = ID_SEARCH_WEB;
	BT[0].fsState	= TBSTATE_ENABLED;
	BT[0].fsStyle	= TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;

	BT[1].iBitmap	= 1;
	BT[1].iString	= 1;
	BT[1].idCommand = ID_SEARCH_PAGE;
	BT[1].fsState	= TBSTATE_ENABLED;
	BT[1].fsStyle	= TBSTYLE_BUTTON;

	BT[2].iBitmap	= 2;
	BT[2].iString	= 2;
	BT[2].idCommand = ID_SEARCH_HILIGHT;
	BT[2].fsState	= TBSTATE_ENABLED;
	BT[2].fsStyle	= TBSTYLE_BUTTON;

	m_wndToolBar.GetToolBarCtrl().AddButtons( 3, BT );
	m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS );
	return 0;
}

void CPatriotSearchbar::OnDestroy()
{
	m_imgLst.DeleteImageList();

	// ŌɑI񂾌GWۑ
	AfxGetApp()->WriteProfileInt( _T("Search"), _T("Default"), m_nActiveEngine );

	// ͗ۑ
	if (g_Options.SearchHistoryCount > 0) {
		//+++ CStdioFile fin(g_Options.strOptionPath +	_T("\\srchhist.dat"), CFile::modeCreate | CFile::modeWrite);
		CWriteTextFile fin(g_Options.strOptionPath +  _T("\\srchhist.dat"), CFile::modeCreate | CFile::modeWrite);
		CString str;
		CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO1);

		int nCount = g_Options.SearchHistoryCount;
		if (nCount > pCombo->GetCount()) {
			nCount = pCombo->GetCount();
		}

		for (int i = 0;i < nCount; i++) {
			pCombo->GetLBText(i, str);
			fin.WriteString( str + _T("\n") );
		}
		fin.Close();
	}

	CDialogBar::OnDestroy();
}

void CPatriotSearchbar::OnSize(UINT nType, int cx, int cy)
{
	CDialogBar::OnSize(nType, cx, cy);
	Invalidate();

	if (cx > 80) {
		// c[o[̈ʒuύX
		CWnd* pCombo = GetDlgItem(IDC_COMBO1);
		if (!pCombo) {
			return;
		}
		CRect rect;
		pCombo->GetClientRect(rect);
		rect.top   = 1;
		rect.right = cx - 80;
		pCombo->MoveWindow(rect);

		rect.left	 = rect.right;
		rect.right	 = cx;
		rect.top	 = 0;
		rect.bottom  = 22;
		m_wndToolBar.MoveWindow(rect);
	}
}

/// bZ[W
BOOL CPatriotSearchbar::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_RBUTTONDOWN && pMsg->wParam & MK_LBUTTON) { // 
		GoUrl();
		return TRUE;
	}
	if (pMsg->message == WM_MBUTTONDOWN) {
		GoUrl();
	}
	if (pMsg->message == WM_KEYDOWN) {
		if (pMsg->wParam== _T('A') && GetKeyState(VK_CONTROL) & 0x8000 ) { // ׂđI
			CComboBox* pSearchCombo = (CComboBox*)GetDlgItem(IDC_COMBO1);
			pSearchCombo->SetEditSel(0, -1);
			return TRUE;
		} else if ( pMsg->wParam == VK_RETURN) { // L[
			GoUrl();
		}
	}
	if (pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_UP) {
		// GWIj[\
		ShowDropDownMenu();
		return TRUE;
	}
	return CDialogBar::PreTranslateMessage(pMsg);
}

/// R{{bNX̕`pR[obN֐
LRESULT CALLBACK CPatriotSearchbar::ComboBoxWndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	if (msg == WM_PAINT
			&& hWnd != ::GetFocus()
			&& ::GetWindowTextLength(hWnd) == 0) {
		// \GW擾
		CMainFrame* pMainFrame = static_cast<CMainFrame*>( AfxGetMainWnd() );
		int 		nIndex	   = pMainFrame->m_wndSearchBar.m_nActiveEngine;
		//CString strEngine = pMainFrame->m_wndSearchBar.m_arrEngines.GetAt(nIndex);
		CString strEngine;
		try {
			if (pMainFrame->m_wndSearchBar.m_arrEngines.GetSize() > 0)	//+++ K[hǉ.
				strEngine = pMainFrame->m_wndSearchBar.m_arrEngines.GetAt(nIndex);
		} catch (...) {
			strEngine = ItoStr(nIndex);
		}

		// GW`
		PAINTSTRUCT paint;
		::BeginPaint( hWnd, &paint );

		HGDIOBJ  hFont	   = reinterpret_cast<HGDIOBJ>( ::SendMessage( hWnd, WM_GETFONT, 0, 0 ) );
		HGDIOBJ  hOldFont  = ::SelectObject( paint.hdc, hFont );
		COLORREF colorGray = ::GetSysColor(COLOR_GRAYTEXT);
		COLORREF colorOld  = ::SetTextColor(paint.hdc, colorGray);

		RECT rect = {0};
		::GetClientRect( hWnd, &rect );

		::ExtTextOut( paint.hdc, 1, 1, ETO_OPAQUE | ETO_CLIPPED, &rect, strEngine, strEngine.GetLength(), NULL);

		::SelectObject(paint.hdc, hOldFont);
		::SetTextColor(paint.hdc, colorOld);
		::EndPaint( hWnd, &paint);
	}
	return CallWindowProc((WNDPROC)m_pComboBoxDefWndProc, hWnd, msg, wParam, lParam);
}

BOOL CPatriotSearchbar::OnEraseBkgnd(CDC* pDC)
{
	CWnd* pParent = GetParent();
	ASSERT_VALID(pParent);

	POINT pt = {0, 0};
	MapWindowPoints(pParent, &pt, 1);
	pt = pDC->OffsetWindowOrg(pt.x, pt.y);
	LRESULT lResult = pParent->SendMessage(WM_ERASEBKGND, (WPARAM)pDC->m_hDC, 0L);
	pDC->SetWindowOrg(pt.x, pt.y);

	return lResult != 0;	//+++ add !=0
}

/// zC[]
BOOL CPatriotSearchbar::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	// y[W{^Ȃy[Ws
	CRect rect;
	m_wndToolBar.GetItemRect( m_wndToolBar.CommandToIndex(ID_SEARCH_PAGE), rect );
	m_wndToolBar.ScreenToClient(&pt);

	if (rect.PtInRect(pt)) {
		CString str;
		GetDlgItem(IDC_COMBO1)->GetWindowText(str);

		if (!str.IsEmpty()) {
			if (zDelta > 0) {
				AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_EDIT_FINDBACK );
			} else {
				AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_EDIT_FINDFORWARD );
			}
		}
	}
	return CDialogBar::OnMouseWheel(nFlags, zDelta, pt);
}

/// ENbNj[
void CPatriotSearchbar::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CRect rectButton;
	m_wndToolBar.GetItemRect( 1, rectButton );
	m_wndToolBar.ClientToScreen( rectButton );

	if (rectButton.PtInRect(point)) { // P
		ShowPageFoundContextMenu(point);
	} else { // ʏ̃j[
		CMenu menu;
		menu.CreatePopupMenu();

		int nSize = int( m_arrEngines.GetSize() );

		for (int i = 0; i < nSize; i++) {
			CString strTitle = m_arrEngines.GetAt(i);

			if (strTitle.Left(2)== _T("--") ) {
				// Zp[^[
				menu.AppendMenu(MF_SEPARATOR , NULL, _T("") );
			} else {
				// V[gJbg\
				if (strTitle == g_Options.strSearchCtrl1) {
					strTitle += _T("\tCtrl+Enter");
				}
				if (strTitle == g_Options.strSearchCtrl2) {
					strTitle += _T("\tShift+Enter");
				}
				if (strTitle == g_Options.strSearchCtrl3) {
					strTitle += _T("\tCtrl+Shift+Enter");
				}

				menu.AppendMenu(MF_STRING, ID_SEARCH_GO + i, strTitle);
			}
		}
		UINT uItem = TrackPopupMenu( menu.m_hMenu, TPM_LEFTALIGN | TPM_RETURNCMD, point.x, point.y, 0, m_hWnd, NULL );
		if (uItem != 0) {
			int tmp = m_nActiveEngine;
			m_nActiveEngine = uItem - ID_SEARCH_GO;
			GoUrl();
			m_nActiveEngine = tmp;
			return;
		}
		menu.DestroyMenu();
	}
}

void CPatriotSearchbar::ShowPageFoundContextMenu(POINT point)
{
  #if 1 //+++	󕶎.
	CComboBox* pCombo = static_cast<CComboBox*>( GetDlgItem(IDC_COMBO1) );
	CString str;
	pCombo->GetWindowText(str);
	if (str.IsEmpty())
		return;
	CMenu menu;
	menu.CreatePopupMenu();
  #else
	CMenu menu;
	menu.CreatePopupMenu();

	CComboBox* pCombo = static_cast<CComboBox*>( GetDlgItem(IDC_COMBO1) );
	CString str;
	pCombo->GetWindowText(str);
  #endif
	CString 	 strWord;

	int 		 i	   = 0;
	int 		 nFind = 0;
	CStringArray arrWord;
	str.Replace( _T("@"), _T(" ") );
	if (str.GetAt( str.GetLength() - 1 ) != _T(' ')) {
		str += _T(' ');
	}

	while ( !str.IsEmpty() ) {
		if (str.GetAt(0)==_T('\"') && (nFind = str.Find( _T("\" "), 1 )) > 0) {
			// ""؂
			strWord = str.Left( nFind + 1 );
			str 	= str.Mid(nFind + 2);
		} else {
			// Xy[X؂
			nFind	= str.Find(_T(' '));
			strWord = str.Left( nFind );
			str 	= str.Mid(nFind + 1);
		}

		if (!strWord.IsEmpty()) {
			menu.AppendMenu( MF_STRING, (UINT)ID_SEARCH_GO + i, strWord );
			arrWord.Add( strWord );
			i++;
		}
	}
	// \
	UINT uItem = TrackPopupMenu( menu.m_hMenu, TPM_LEFTALIGN | TPM_RETURNCMD, point.x, point.y, 0, m_hWnd, NULL );
	if (uItem != 0) {
		// I
		i = uItem - ID_SEARCH_GO;
		pCombo->GetWindowText( str );
		int nStart = str.Find( arrWord.GetAt(i) );
		int nEnd   = nStart + arrWord.GetAt(i).GetLength();

		// 1.0.05 SetEditSel  WCHAR ւ̕ϊsv
		// 1.2.00 comctrl32.dll ver.6 ̕sANSIrhłUnicodegpĂ܂
		//		  ƂăR{{bNX Unicode łŋύX
		BOOL bIsUnicode = IsWindowUnicode(pCombo->GetSafeHwnd());
		if (bIsUnicode) {
			CComBSTR bstr  = str.Left(nStart);
			nStart		   = bstr.Length();
			CComBSTR bstr2 = arrWord.GetAt(i);
			nEnd		   = nStart + bstr2.Length();
		}

		pCombo->SetEditSel(nStart, nEnd);
		AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_EDIT_FINDFORWARD );
	}
}

void CPatriotSearchbar::OnSetfocusCombo1()
{
	TCHAR lpClassName[MAX_PATH];
	CWnd* pFocusWnd = GetFocus();
	if (pFocusWnd) {
		GetClassName(pFocusWnd->m_hWnd, lpClassName, MAX_PATH);
		if (lstrcmp(lpClassName, _T("Edit")) == 0) {
			pFocusWnd->ModifyStyle(0, ES_NOHIDESEL);
		}
	}
}

void CPatriotSearchbar::OnKillfocusCombo1()
{
	GetDlgItem(IDC_COMBO1)->GetTopWindow()->RedrawWindow();
}

/// WEB{^
void CPatriotSearchbar::OnSearchWeb()
{
	GoUrl();
}
void CPatriotSearchbar::OnUpdateSearchWeb(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

/// {^
void CPatriotSearchbar::OnSearchPage()
{
	if (GetKeyState(VK_SHIFT) & 0x8000) {
		SendMessage(WM_COMMAND , ID_EDIT_FINDBACK);
	} else {
		SendMessage(WM_COMMAND , ID_EDIT_FINDFORWARD);
	}
}
void CPatriotSearchbar::OnUpdateSearchPage(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

// nCCg{^
void CPatriotSearchbar::OnSearchHilight()
{
	CMDIChildWnd* pFrame = ((CMDIFrameWnd*)AfxGetMainWnd())->MDIGetActive();
	if (pFrame == NULL) {
		return;
	}

	CPatriotView* pView = (CPatriotView*) pFrame->GetActiveView();
	if ( pView->m_strHilightWord.IsEmpty() ) {
		SendMessage( WM_COMMAND, ID_EDIT_HILIGHT );
	} else {
		pView->SendMessage( WM_HIGHLIGHTPAGE, (WPARAM)_T(""), 0 );		//+++@ cast chg.
	}

}
void CPatriotSearchbar::OnUpdateSearchHilight(CCmdUI* pCmdUI)
{
	CMDIChildWnd* pFrame = ((CMDIFrameWnd*)AfxGetMainWnd())->MDIGetActive();
	if (pFrame) {
		CPatriotView* pView= (CPatriotView*) pFrame->GetActiveView();
		pCmdUI->SetCheck( !pView->m_strHilightWord.IsEmpty() );
	} else {
		pCmdUI->SetCheck( 0 );
	}
}

/// c[o[̃hbv_E
void CPatriotSearchbar::OnDropDown(NMHDR* pNotifyStruct, LRESULT* pResult)
{
	NMTOOLBAR* pNMToolBar = (NMTOOLBAR*)pNotifyStruct;
	if (pNMToolBar->iItem != ID_SEARCH_WEB) {
		return;
	}
	*pResult = TBDDRET_DEFAULT;

	ShowDropDownMenu();
}

/// I𕶎擾
CString CPatriotSearchbar::GetSelText()
{
	CString str;
	// I𕶎
	CComboBox* pCombo = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO1));
	DWORD dwEditSel = pCombo->GetEditSel();
	if (HIWORD(dwEditSel) != LOWORD(dwEditSel)) {
		// WindowsXP SP1 ̓̃o[Wȍ~ MBSC ł CB_GETEDITSEL 
		// ԂBoCgԂ邽߁A
		// NT nł SendMessageW ŏɕ悤
		pCombo->GetWindowText(str);

		HWND hwndCombo = pCombo->GetSafeHwnd();

		DWORD dwStart, dwEnd;
		if (IsComboUnicode()) {
			::SendMessageW(hwndCombo, CB_GETEDITSEL, reinterpret_cast<WPARAM>(&dwStart), reinterpret_cast<LPARAM>(&dwEnd));
			USES_CONVERSION;
		  #ifdef UNICODE
			str = CString(LPCTSTR(str)+dwStart, dwEnd-dwStart);
		  #else
			LPWSTR wstr = T2W(str);
			wstr[dwEnd] = L'\0';
			wstr += dwStart;
			str = W2T(wstr);
		  #endif
		} else {
			::SendMessageA(hwndCombo, CB_GETEDITSEL, reinterpret_cast<WPARAM>(&dwStart), reinterpret_cast<LPARAM>(&dwEnd));
			str = str.Mid(dwStart, dwEnd - dwStart);
		}
	}
	return str;
}

/// I𕶎ݒ
void CPatriotSearchbar::SetSelText(const CString& strText)
{
	// WindowsXP SP1 ̓̃o[Wȍ~ MBSC ł CB_SETEDITSEL 
	// ԂBoCgԂ邽߁A
	// NT nł SendMessageW ŏɕ悤
	CComboBox* pCombo = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO1));

	CString str;
	pCombo->GetWindowText(str);

	int nStart = str.Find(strText);
	int nEnd = nStart + strText.GetLength();

	HWND hwndCombo = pCombo->GetSafeHwnd();
	if (IsComboUnicode()) {
		CComBSTR bstr = str.Left(nStart);
		nStart = bstr.Length();
		CComBSTR bstr2 = strText;
		nEnd = nStart + bstr2.Length();
		::SendMessageW(hwndCombo, CB_SETEDITSEL, 0, MAKELPARAM(nStart, nEnd));
	} else {
		::SendMessageA(hwndCombo, CB_SETEDITSEL, 0, MAKELPARAM(nStart, nEnd));
	}
}

/// R{{bNXUnicode`FbN
BOOL CPatriotSearchbar::IsComboUnicode()
{
	CString str;
	// I𕶎
	CComboBox* pCombo = static_cast<CComboBox*>(GetDlgItem(IDC_COMBO1));
	if (::IsWindowUnicode(pCombo->GetSafeHwnd())) {
		return TRUE;
	} else if (!IsPlatformNt()) {
		return FALSE;
	}

	DWORD dwEditSel = pCombo->GetEditSel();
	pCombo->GetWindowText(str);
	pCombo->SetEditSel(0, -1);
	DWORD dwEditSelAll = pCombo->GetEditSel();
	pCombo->SetEditSel(LOWORD(dwEditSel), HIWORD(dwEditSel));

	int dwSelLength = HIWORD(dwEditSelAll) - LOWORD(dwEditSelAll);
	if (dwSelLength < str.GetLength()) {
		return TRUE;
	}
	return FALSE;
}
