/**
 *	@file	ReadWriteTextFile.h
 *	@brief	 `t@C̓ǂݏ̂߂ CStudioFilȇ֕i
 *	@author	+mod
 *	@note
 *		eLXgt@Cǂݍ݃NX.
 *		UNICODERpC CStdioFileReadStringSJISt@Cǂݍނ
 *		̂ŁA̒up.
 *		`t@CSʂutf-8ǁAPrivateProfilen API
 *		pĂ邽߁AR[hOSftHg(CP932)łȂƑʖڂ
 *		t@C͗l.
 *		(ŁAPrivateProfilengpƂ킩Ă郂mʂɐݒ肷j)
 */
#ifndef READWRITETEXTFILE_H
#define READWRITETEXTFILE_H

#include <vector>
#include <cassert>
#if _MSC_VER >= 1300
#include <afxstr.h>
#else
#include <malloc.h>
#endif

#if 1 //def UNICODE
///+++ eLXgt@Cǂݍ݃NX. UNICODERpC CStdioFileReadStringSJISt@Cǂݍނƕ̂ŁA̒up.
class CReadTextFile {
public:
	CReadTextFile() : m_cur(0), m_utf8(0) { }
	CReadTextFile(const CString& fname, unsigned mode=CFile::modeRead) { Open(fname, mode); }

	bool Open(const CString& fname, unsigned mode=CFile::modeRead) {
		m_fname = fname;
		m_cur	= 0;
		m_utf8	= 0;
		CFile	fi;
		bool	rc = fi.Open( fname, mode ) != 0;
		if (rc) {
			ASSERT(fi.GetLength() <= 0x200000); // ق̏ȃeLXgt@Cz. 2Mȏ゠AEgɂƂ.
			unsigned	size  = unsigned(fi.GetLength());
			m_buf.resize(size + 1);
			unsigned	rsize = fi.Read(&m_buf[0], size);
			rc = (rsize == size);
			m_buf[size] = 0;
			if (size >= 3) {
				const unsigned char* s = (const unsigned char*)&m_buf[0];
				if (s[0] == 0xEF && s[1] == 0xBB && s[2] == 0xBF) { // UTF-8BOMutf8
					m_utf8 = 1;
					m_cur  = 3;
				}
			}
		}
		return rc;
	}

	BOOL ReadString(CString& rStr, size_t capa=0x7fffffff) {
		ASSERT(capa > 1 && capa <= 0x7fffffff);
		unsigned   maxlen = unsigned(capa - 1);
		unsigned   size   = unsigned( m_buf.size() );
		if (size)
			--size;
		if (size == 0 || m_cur >= size)
			return 0;
		const char* buf = &m_buf[0];
		const char* s	= &buf[m_cur];
		const char* p	= s;
		const char* e	= &buf[size];
		unsigned	skp = 0;
		do {
			unsigned c = *p;
			if (c == '\n' || c == '\0') {
				//*p = 0;
				skp  = 1;
				break;
			} else if (c == '\r' && p+1 < e && p[1] == '\n') {
				//*p	= 0;
				//p[1]	= 0;
				skp 	= 2;
				break;
			}
			++p;
		} while (p != e);
		m_cur	   = p + skp - buf;
		unsigned l = unsigned(p - s);

		// eLXg1sǂݍ݂allocałƂĂ.
	  #ifdef UNICODE
		unsigned bytes = (l+1) * 2;
		ASSERT( bytes <= 0x100000 );
		WCHAR*	 a	   = (WCHAR*)alloca(bytes+2);
		unsigned cp    = m_utf8 ? 65001 : 0/*CP_ANSI*/;
		unsigned nChars= ::MultiByteToWideChar(cp, 0, s, int(l), a, bytes);
		if (nChars > maxlen)
			nChars	   = maxlen;
		a[nChars]	   = 0;
		rStr		   = a;
		return nChars > 0;
	  #else
		if (m_utf8 == 0) {	//+++
			rStr = CString(s, int(l));
		} else {	//+++ utf-8̏ꍇ.
			unsigned bytes = (l+1) * 2;
			ASSERT( bytes <= 0x100000 );
			WCHAR*	 wstr  = (WCHAR*)alloca(bytes+2);
			unsigned nChars= ::MultiByteToWideChar(65001, 0, s, int(l), wstr, bytes);
			if (nChars > maxlen)
				nChars	   = maxlen;
			wstr[nChars]   = 0;
			bytes		   = (nChars + 1) * 2;
			char*	 mbs   = (char*)alloca(bytes);
			bytes		   = ::WideCharToMultiByte(0, 0, wstr, int(l), mbs, bytes, NULL, NULL);
			rStr		   = mbs;
		}
		return l > 0;
	  #endif
	}

	void Close() {
		m_fname.Empty();
		m_buf.clear();
		m_cur = 0;
	}

private:
	CString 			m_fname;
	std::vector<char>	m_buf;
	size_t				m_cur;
	bool				m_utf8;
};

#else

#define CReadTextFile	CStdioFile

#endif



#if 1
///+++ eLXgt@C݃NX. CStdioFile̒up.
class CWriteTextFile {
public:
	CWriteTextFile() : m_fmode(0), m_appendMode(0) { }
	CWriteTextFile(const CString& fname, unsigned fmode, bool apnMd=0, bool unicodeSw=0) {
		Open(fname, fmode, apnMd, unicodeSw);
	}
	~CWriteTextFile() { Close(); }

	bool Open(const CString& fname, unsigned fmode, bool appendMode=0, bool unicodeSw=0) {
		m_fname 	  = fname;		// t@CpX.
		m_fmode 	  = fmode;		// t@C[h. r/w
		m_appendMode  = appendMode; // ǋL[h
		m_unicodeSw   = unicodeSw;	// o͂utf-8ɂ邩ۂ.
		m_buf.reserve( 0x40000 );	// 256K\(m).
		return 1;
	}

	// ̃t@C (Aɒ߂邾ŁAt@CւCloseɏ)
	BOOL WriteString(LPCTSTR s) {
		while (*s) {
			unsigned c = *s++;
			if (c == '\n') {
				m_buf.push_back(TCHAR('\r'));
			} else if (c == '\r' && *s == '\n') {
				m_buf.push_back(TCHAR(c));
				c = '\n';
				++s;
			}
		  #if 0 // ǋL̏ꍇAt@C̔肪łȂ̂ŁAencode͌ߑłɂ.
			else if (c >= 0x80) {
				m_havNonAscii = 1;
			}
		  #endif
			m_buf.push_back(TCHAR(c));
		}
		return TRUE;
	}

	void Close() {
		if (m_fname.IsEmpty()) {
			return;
		}
		ASSERT( m_buf.size() <= 0x1000000 );	//+++ prIɖcłȂ͂Ȃ̂ŁAÔ 16M܂łƂĂ.
		unsigned l = unsigned(m_buf.size());
		if (l) {
			m_buf.push_back(0);
		  #ifdef UNICODE
			unsigned cp 	= m_unicodeSw ? 65001 : 0;		// unicode or sjis.
			TCHAR*	 s		= &m_buf[0];
			unsigned nBytes = ::WideCharToMultiByte(cp, 0, s, int(l), 0, 0, NULL, NULL);
			std::vector<char>	dst( nBytes + 16 );
			::WideCharToMultiByte(cp, 0, s, l, &dst[0], nBytes, NULL, NULL);
			CFile	 fi;
			bool	 rc = fi.Open( m_fname, m_fmode ) != 0;
			if (rc) {
				ULONGLONG len = 0;
				if (m_appendMode)		// filter.dat  extension/user.ini ɑ΂ǋLsꍇ.
					len 	  = fi.SeekToEnd();
				if (len == 0 && m_unicodeSw)	// ǋLłȂ,,unicodew肳ĂAutf-8bomt.
					fi.Write("\xEF\xBB\xBF", 3);
				fi.Write(&dst[0], nBytes);
				fi.Close();
			}
		  #else // SJIS ł̂Ƃ.  ӖȂ̂ unicodeo͎w̓V.
			CFile	fi;
			bool	rc = fi.Open( m_fname, m_fmode ) != 0;
			if (rc) {
				if (m_appendMode)
					fi.SeekToEnd();
				fi.Write(&m_buf[0], l);
				fi.Close();
			}
		  #endif
		}
		m_fname.Empty();
		m_buf.clear();
		m_fmode 	 = 0;
		m_appendMode = 0;
		m_unicodeSw  = 0;
	}

private:
	CString 			m_fname;
	unsigned			m_fmode;
	bool				m_appendMode;
	bool				m_unicodeSw;
	std::vector<TCHAR>	m_buf;
};

#else	//+++ appendModeƂ悤gAAǂȂ.
#define CWriteTextFile		CStdioFile
#endif


#endif	// READWRITETEXTFILE_H
