#if !defined(PATRIOT_CLASS_BURAPI)
#define PATRIOT_CLASS_BURAPI

//[U[bZ[W
#define BURAPI_GETVERSION			WM_APP + 1
#define BURAPI_GET_SPECIAL_FOLDER	WM_APP + 2
#define BURAPI_GETTABCOUNT			WM_APP + 3
#define BURAPI_GETACTIVETAB 		WM_APP + 4
#define BURAPI_SETACTIVETAB 		WM_APP + 5
#define BURAPI_GETBROWSER			WM_APP + 6
#define BURAPI_GETACTIVEDOCUMENT	WM_APP + 7
#define BURAPI_NEWTAB				WM_APP + 8
#define BURAPI_CLOSETAB 			WM_APP + 9
#define BURAPI_GETTABOPTION 		WM_APP + 10
#define BURAPI_SETTABOPTION 		WM_APP + 11
#define BURAPI_GETSELECTEDSTR		WM_APP + 12
#define BURAPI_GETSELECTEDHTML		WM_APP + 13

#define BURA_SPFOLDER_EXE		0
#define BURA_SPFOLDER_OPTION	1
#define BURA_SPFOLDER_EXTENSION 2
#define BURA_SPFOLDER_FAVORITES 3
#define BURA_SPFOLDER_TEMPOLALY 4
#define BURA_SPFOLDER_RESOURCE	5
#define BURA_SPFOLDER_URLLIST	6

#define BURA_GET_MARSHAL_STREAM 1 << 16

#endif // PATRIOT_CLASS_BURAPI

#if defined(PATRIOT_CLASS_TRANSLATE_BURAPI_MESSAGE)
#if !defined(PATRIOT_CLASS_BURAPI_FUNC)
#define PATRIOT_CLASS_BURAPI_FUNC

#include "stdafx.h"
#include "patriotGlobalDom.h"

class CBurapi
{
public:
	LRESULT TranslateMessage( UINT message, WPARAM wParam, LPARAM lParam );

	afx_msg LRESULT OnGetVersion( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetSpecialFolder( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetTabCount( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetActiveTab( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnSetActiveTab( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetBrowser( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetActiveDocument( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnNewTab( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnCloseTab( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetTabOption( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnSetTabOption( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetSelectedStr( WPARAM wParam = 0, LPARAM lParam = 0 );
	afx_msg LRESULT OnGetSelectedHtml( WPARAM wParam = 0, LPARAM lParam = 0 );
};

LRESULT CBurapi::TranslateMessage( UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message) {
	case BURAPI_GETVERSION:
		return OnGetVersion( wParam, lParam );
	case BURAPI_GET_SPECIAL_FOLDER:
		return OnGetSpecialFolder( wParam, lParam );
	case BURAPI_GETTABCOUNT:
		return OnGetTabCount( wParam, lParam );
	case BURAPI_GETACTIVETAB:
		return OnGetActiveTab( wParam, lParam );
	case BURAPI_SETACTIVETAB:
		return OnSetActiveTab( wParam, lParam );
	case BURAPI_GETBROWSER:
		return OnGetBrowser( wParam, lParam );
	case BURAPI_GETACTIVEDOCUMENT:
		return OnGetActiveDocument( wParam, lParam );
	case BURAPI_NEWTAB:
		return OnNewTab( wParam, lParam );
	case BURAPI_CLOSETAB:
		return OnCloseTab( wParam, lParam );
	case BURAPI_GETTABOPTION:
		return OnGetTabOption( wParam, lParam );
	case BURAPI_SETTABOPTION:
		return OnSetTabOption( wParam, lParam );
	case BURAPI_GETSELECTEDSTR:
		return OnGetSelectedStr( wParam, lParam );
	case BURAPI_GETSELECTEDHTML:
		return OnGetSelectedHtml( wParam, lParam );
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////
// CBurapi
//////////////////////////////////////////////////////////////////////////////////////////////

/// o[W
LRESULT CBurapi::OnGetVersion(WPARAM wParam, LPARAM lParam)
{
	return 101;
}

/// tH_擾
LRESULT CBurapi::OnGetSpecialFolder(WPARAM wParam, LPARAM lParam)
{
	CString strFolder;
	switch(wParam){
	case BURA_SPFOLDER_OPTION://optiontH_
		strFolder = g_Options.strOptionPath;
		break;
	case BURA_SPFOLDER_EXTENSION:
		strFolder = g_Options.strAppPath+ _T("\\extension");
		break;
	case BURA_SPFOLDER_FAVORITES:
		strFolder = g_Options.strFavorites;
		break;
	case BURA_SPFOLDER_TEMPOLALY:
		strFolder = GetTempFolder();
		break;
	case BURA_SPFOLDER_RESOURCE:
		strFolder = g_Options.strAppPath + _T("\\res");
		break;
	case BURA_SPFOLDER_URLLIST:
		strFolder = g_Options.strUrllistPath;
		break;
	}
	lstrcpy((TCHAR*)lParam, strFolder);
	return TRUE;
}

/// ^u擾
LRESULT CBurapi::OnGetTabCount(WPARAM wParam, LPARAM lParam)
{
	return ((CMainFrame*)AfxGetMainWnd())->m_Tabs.count;
}

/// ANeBuȃ^u index 擾
LRESULT CBurapi::OnGetActiveTab(WPARAM wParam, LPARAM lParam)
{
	return ((CMainFrame*)AfxGetMainWnd())->m_wndTabBar.GetCurSel();
}

/// ANeBuȃ^uݒ
LRESULT CBurapi::OnSetActiveTab(WPARAM wParam, LPARAM lParam)
{
	((CMainFrame*)AfxGetMainWnd())->SetTab(int(wParam));
	return TRUE;
}

/// w肵 index  IWebBrowser2 擾
LRESULT CBurapi::OnGetBrowser(WPARAM wParam, LPARAM lParam)
{
	int TabIndex = LOWORD(wParam);
	CMainFrame* pFrame = static_cast<CMainFrame*>( AfxGetMainWnd() );
	if ( pFrame->m_Tabs.count == 0 || (int)TabIndex >= pFrame->m_Tabs.count || TabIndex < 0 ) {
		return FALSE;
	}

	LPDISPATCH pDisp = (((CPatriotView*)pFrame->m_Tabs.pView[TabIndex])->GetApplication());
	if (wParam & BURA_GET_MARSHAL_STREAM) {
		::CoMarshalInterThreadInterfaceInStream( IID_IDispatch, pDisp, (IStream**)(void**)lParam);
		pDisp->Release();
	} else {
		(*(void**)lParam) = pDisp;
	}
	return TRUE;
}

/// w肵 index ̃^uŃtH[JX̂ IHTMLDocument 擾
LRESULT CBurapi::OnGetActiveDocument(WPARAM wParam, LPARAM lParam)
{
	int TabIndex = LOWORD(wParam);
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if ( pFrame->m_Tabs.count == 0 || (int)TabIndex >= pFrame->m_Tabs.count || TabIndex < 0 ) {
		return FALSE;
	}

	LPDISPATCH pDisp = GetActiveDocument(pFrame->m_Tabs.pView[TabIndex]);
	if (wParam & BURA_GET_MARSHAL_STREAM) {
		::CoMarshalInterThreadInterfaceInStream( IID_IDispatch, pDisp, (LPSTREAM*)(void**)lParam);
		pDisp->Release();
	} else {
		(*(void**)lParam) = pDisp;
	}
	return TRUE;
}

/// URL J
LRESULT CBurapi::OnNewTab(WPARAM wParam, LPARAM lParam)
{
	LPCTSTR strUrl = (LPCTSTR)lParam;

	int bActive = 2;
	if (wParam & 1) {
		bActive = 1;
	} else if (wParam & 2) {
		bActive = 0;
	}

	BOOL bChildOfTab = (wParam & 4);

	CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	if (bChildOfTab && pFrame->MDIGetActive()) {//
		CPatriotView* pView = ((CPatriotView*)pFrame->MDIGetActive()->GetActiveView());
		pView->OpenURL( strUrl, TRUE, bActive, FALSE );
		return pView->m_TabIndex;
	} else { // ^uȂ
		CPatriotView* pView = ((CPatriotView*)((CPatriotApp*)AfxGetApp())->NewTab( 1, bActive ));
		if ( lstrlen(strUrl) != 0 ) {
			pView->Navigate(strUrl);
		}
		return pView->m_TabIndex;
	}
	//+++ return -1;	//+++ ɂ͂Ȃ.
}

/// ^u
LRESULT CBurapi::OnCloseTab( WPARAM wParam, LPARAM lParam )
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if (pFrame->m_Tabs.count == 0 || (int)wParam>=pFrame->m_Tabs.count || wParam < 0) {
		return FALSE;
	}
	pFrame->m_Tabs.pView[wParam]->SendMessage(WM_COMMAND , ID_FILE_CLOSE);
	return TRUE;
}

/// 
LRESULT CBurapi::OnGetTabOption( WPARAM wParam, LPARAM lParam )
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if (pFrame->m_Tabs.count == 0 || (int)wParam>=pFrame->m_Tabs.count || wParam < 0) {
		return FALSE;
	}
	return FALSE;
}

/// 
LRESULT CBurapi::OnSetTabOption( WPARAM wParam, LPARAM lParam )
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if (pFrame->m_Tabs.count == 0 || (int)wParam>=pFrame->m_Tabs.count || wParam < 0)
		return FALSE;
	return FALSE;
}

/// I𕶎擾
LRESULT CBurapi::OnGetSelectedStr( WPARAM wParam, LPARAM lParam )
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if (pFrame->m_Tabs.count == 0 || (int)wParam>=pFrame->m_Tabs.count || wParam < 0) {
		return FALSE;
	}

	CString str = GetSelectedText(pFrame->m_Tabs.pView[wParam], FALSE);
	lstrcpy((LPTSTR)lParam, str);
	return TRUE;
}

/// I͈͂ HTML 擾
LRESULT CBurapi::OnGetSelectedHtml( WPARAM wParam, LPARAM lParam )
{
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if (pFrame->m_Tabs.count == 0 || (int)wParam>=pFrame->m_Tabs.count || wParam < 0) {
		return FALSE;
	}

	CString str = GetSelectedText( pFrame->m_Tabs.pView[wParam], TRUE );
	lstrcpy((LPTSTR)lParam, str);
	return TRUE;
}

#endif // PATRIOT_CLASS_BURAPI_FUNC
#endif